<template>
  <label class="b-checkbox checkbox" :class="etatCss">
    <span class="check" @click="click"></span>
  </label>
</template>

<script>
import newCheckboxAllEtat from '~/components/mixins/checkboxAllMixin';

export default {
  name: 'MtCheckboxAll',
  props: {
    etat: {
      type: Object,
      default: () => newCheckboxAllEtat(),
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      valeur: false,
    };
  },
  computed: {
    etatCss() {
      if (this.disabled) {
        return 'disabled';
      }
      if (this.etat.indeterminate) {
        return 'indeterminate';
      }
      if (this.etat.checked) {
        return 'checked';
      }
      return '';
    },
  },
  methods: {
    click() {
      if (!this.disabled) {
        if (this.etat.checked) {
          this.valeur = true;
        }
        this.valeur = !this.valeur;
        this.$emit('click', this.valeur);
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.b-checkbox.checkbox {
  display: flex;

  &.disabled {
    .check:hover,
    .check {
      border: solid 1px $grey-light;
      background-color: #f7f7f7;
      cursor: not-allowed;
    }
  }
  .check {
    border-radius: 3px;
    border: solid 1px $periwinkle-light;
    background-color: $pale-grey-three;
    position: relative;
    display: flex;
    align-items: center;
    justify-content: center;
    margin-right: 0.5rem;

    width: 1.25em;
    height: 1.25em;
    flex-shrink: 0;
    transition: background, border-color 0.3s;

    &::before {
      content: '';
      position: absolute;
      height: 0.4375rem;
      width: 0.5625rem;
      border-bottom: 0.1875rem solid transparent;
      border-left: 0.1875rem solid transparent;
      transform: rotate(-45deg) skewX(-5deg);
      transition: border-color 0.3s;
      margin-top: -1px;
    }

    &:hover {
      border-color: $soft-blue;
    }
  }

  &.indeterminate .check {
    background-color: $soft-blue;
    border-color: $soft-blue;
    &::before {
      content: '';
      position: absolute;
      height: 0.2em;
      width: 0.75em;
      background-color: white;
      transform: unset;
    }
  }
  &.checked .check {
    background-color: $soft-blue;
    border-color: $soft-blue;

    &::before {
      border-color: $white;
    }
  }
}
</style>
